﻿using System;
using System.Linq;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;

namespace OnTimeApp.API.Installers
{
    public static class InstallerExtensions
    {
        public static void InstallServicesInAssembly(this IServiceCollection services, IConfiguration configuration)
        {
            var installers = typeof(Startup).Assembly.ExportedTypes
                .Where(x => typeof(IInstaller).IsAssignableFrom(x) &&
                            !x.IsInterface &&
                            !x.IsAbstract)
                .Select(Activator.CreateInstance)
                .Cast<IInstaller>();
            foreach (var installer in installers)
            {
                installer.InstallServices(services, configuration);
            }
        }
    }
}