# swagger
No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This Dart package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1
- Build package: io.swagger.codegen.languages.DartClientCodegen

## Requirements

Dart 1.20.0 or later OR Flutter 0.0.20 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: swagger
version: 1.0.0
description: Swagger API client
dependencies:
  swagger:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  swagger:
    path: /path/to/swagger
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:swagger/api.dart';

// TODO Configure API key authorization: Bearer
//swagger.api.Configuration.apiKey{'Authorization'} = 'YOUR_API_KEY';
// uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//swagger.api.Configuration.apiKeyPrefix{'Authorization'} = "Bearer";

var api_instance = new CheckInRecordsApi();
var email = email_example; // String | 
var date = 2013-10-20T19:20:30+01:00; // DateTime | 

try {
    var result = api_instance.apiV1CheckInRecordsEmailDateGet(email, date);
    print(result);
} catch (e) {
    print("Exception when calling CheckInRecordsApi->apiV1CheckInRecordsEmailDateGet: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CheckInRecordsApi* | [**apiV1CheckInRecordsEmailDateGet**](docs//CheckInRecordsApi.md#apiv1checkinrecordsemaildateget) | **GET** /api/v1/CheckInRecords/{email}/{date} | 
*CheckInRecordsApi* | [**apiV1CheckInRecordsEmailFromToGet**](docs//CheckInRecordsApi.md#apiv1checkinrecordsemailfromtoget) | **GET** /api/v1/CheckInRecords/{email}/{from}/{to} | 
*CheckInRecordsApi* | [**apiV1CheckInRecordsEmailGet**](docs//CheckInRecordsApi.md#apiv1checkinrecordsemailget) | **GET** /api/v1/CheckInRecords/{email} | 
*CheckInRecordsApi* | [**apiV1CheckInRecordsGet**](docs//CheckInRecordsApi.md#apiv1checkinrecordsget) | **GET** /api/v1/CheckInRecords | 
*CheckInRecordsApi* | [**apiV1CheckInRecordsRegisterPost**](docs//CheckInRecordsApi.md#apiv1checkinrecordsregisterpost) | **POST** /api/v1/CheckInRecords/Register | 
*CheckInRecordsApi* | [**apiV1CheckInRecordsWorkedTimeEmailDateGet**](docs//CheckInRecordsApi.md#apiv1checkinrecordsworkedtimeemaildateget) | **GET** /api/v1/CheckInRecords/WorkedTime/{email}/{date} | 
*HolidaysApi* | [**apiV1HolidaysApprovePost**](docs//HolidaysApi.md#apiv1holidaysapprovepost) | **POST** /api/v1/Holidays/Approve | Approve an existing Holiday request
*HolidaysApi* | [**apiV1HolidaysDeletePost**](docs//HolidaysApi.md#apiv1holidaysdeletepost) | **POST** /api/v1/Holidays/Delete | Delete an existing Holiday request
*HolidaysApi* | [**apiV1HolidaysEmailFromToGet**](docs//HolidaysApi.md#apiv1holidaysemailfromtoget) | **GET** /api/v1/Holidays/{email}/{from}/{to} | Get a set of request that belong to the user with the passed email between the years from and to
*HolidaysApi* | [**apiV1HolidaysRegisterPost**](docs//HolidaysApi.md#apiv1holidaysregisterpost) | **POST** /api/v1/Holidays/Register | Register a new leave request
*HolidaysApi* | [**apiV1HolidaysToApproveEmailGet**](docs//HolidaysApi.md#apiv1holidaystoapproveemailget) | **GET** /api/v1/Holidays/ToApprove/{email} | Get the Holiday requests that the user has to approve
*IdentityApi* | [**apiV1IdentityInitPost**](docs//IdentityApi.md#apiv1identityinitpost) | **POST** /api/v1/Identity/init | Creates default admin user, this is added because we do not have a real database where to add this info.  We use an in memory db so each time the service is restarted, this should be called
*IdentityApi* | [**apiV1IdentityLoginPost**](docs//IdentityApi.md#apiv1identityloginpost) | **POST** /api/v1/Identity/login | Login user in the system
*IdentityApi* | [**apiV1IdentityRegisterPost**](docs//IdentityApi.md#apiv1identityregisterpost) | **POST** /api/v1/Identity/register | Register a new user in the system
*RolesApi* | [**apiV1RolesGet**](docs//RolesApi.md#apiv1rolesget) | **GET** /api/v1/Roles | 
*RolesApi* | [**apiV1RolesRegisterPost**](docs//RolesApi.md#apiv1rolesregisterpost) | **POST** /api/v1/Roles/register | 
*UsersApi* | [**apiV1UsersAddRolePost**](docs//UsersApi.md#apiv1usersaddrolepost) | **POST** /api/v1/Users/AddRole | 
*UsersApi* | [**apiV1UsersAddSubordiantePost**](docs//UsersApi.md#apiv1usersaddsubordiantepost) | **POST** /api/v1/Users/AddSubordiante | 
*UsersApi* | [**apiV1UsersEmailGet**](docs//UsersApi.md#apiv1usersemailget) | **GET** /api/v1/Users/{email} | 
*UsersApi* | [**apiV1UsersGet**](docs//UsersApi.md#apiv1usersget) | **GET** /api/v1/Users | 
*UsersApi* | [**apiV1UsersGetRolesEmailGet**](docs//UsersApi.md#apiv1usersgetrolesemailget) | **GET** /api/v1/Users/GetRoles/{email} | 
*UsersApi* | [**apiV1UsersRemoveRolePost**](docs//UsersApi.md#apiv1usersremoverolepost) | **POST** /api/v1/Users/RemoveRole | 
*UsersApi* | [**apiV1UsersSubordinatesEmailGet**](docs//UsersApi.md#apiv1userssubordinatesemailget) | **GET** /api/v1/Users/Subordinates/{email} | 


## Documentation For Models

 - [AuthResponse](docs//AuthResponse.md)
 - [CheckInResgistrationRequest](docs//CheckInResgistrationRequest.md)
 - [CheckInResponse](docs//CheckInResponse.md)
 - [CheckInResponseResponseSet](docs//CheckInResponseResponseSet.md)
 - [HolidayApproveRequest](docs//HolidayApproveRequest.md)
 - [HolidayDeleteRequest](docs//HolidayDeleteRequest.md)
 - [HolidayRequestRegistration](docs//HolidayRequestRegistration.md)
 - [HolidayRequestResponse](docs//HolidayRequestResponse.md)
 - [HolidayRequestResponseResponseSet](docs//HolidayRequestResponseResponseSet.md)
 - [RoleRegistrationRequest](docs//RoleRegistrationRequest.md)
 - [RoleResponse](docs//RoleResponse.md)
 - [RoleResponseResponseSet](docs//RoleResponseResponseSet.md)
 - [StringResponseSet](docs//StringResponseSet.md)
 - [UserAddSubordinateRequest](docs//UserAddSubordinateRequest.md)
 - [UserLoginRequest](docs//UserLoginRequest.md)
 - [UserRegistrationRequest](docs//UserRegistrationRequest.md)
 - [UserResponse](docs//UserResponse.md)
 - [UserResponseResponseSet](docs//UserResponseResponseSet.md)
 - [UserRoleAdditionRequest](docs//UserRoleAdditionRequest.md)
 - [UserRoleRemoveRequest](docs//UserRoleRemoveRequest.md)
 - [WorkedTimeResponse](docs//WorkedTimeResponse.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

sergiojj932@gmail.com


